{% extends 'base.html' %}
{% load static %}

{% block meta %}
<title>Custom kubus</title>

{% endblock meta %}

{% block content %}
<div class = "container" style="margin-top: 100px; margin-bottom: 100px;">
    koordinat x awal = <input type="number" id="x0" required/>
    <br />
    koordinat x akhir = <input type="number" id="xt" required/>
    <br />
    koordinat y awal = <input type="number" id="y0" required/>
    <br />
    koordinat y akhir = <input type="number" id="yt" required/>
    <br />
    koordinat z awal = <input type="number" id="z0" required/>
    <br />
    koordinat z akhir = <input type="number" id="zt" required/>
    <br />
    densitas = <input type="number" id="d" required/>
    <br />
    warna = <input type="color" id = "c" required>
    <br />
    <button type="button" onclick="cetak()">Cetak</button>
    <p id="demo"></p>
    <script>
    var path_save= "";
    if ( window.location.pathname.length > 8 ) { // memeriksa apakah link document diawali dengan # atau tidak
            
        path_save = window.location.pathname.substr( 8 );
        path_save = path_save.split("/")[0];
        
        }

    function cetak() {
        var x0 = document.getElementById("x0").value ;
        var xt = document.getElementById("xt").value ;
        var y0 = document.getElementById("y0").value ;
        var yt = document.getElementById("yt").value ;
        var z0 = document.getElementById("z0").value ;
        var zt = document.getElementById("zt").value ;
        var d = document.getElementById("d").value ;
        var c = document.getElementById("c").value ;
        var ketemu = false;
        var data =buildFromHash();

        if(ketemu == true){
            alert("Maaf, sudah terdapat box pada area yang anda pilih");
        }else if(x0-xt>0 || y0-yt>0 || z0-zt>0){
            alert("Maaf, koordinat akhir harus lebih besar dari koordinat awal");
        }else if(path_save.search("]") == -1){
            window.location.href="/model3d/"+path_save+"["+x0+":"+xt+":"+y0+":"+yt+":"+z0+":"+zt+":"+d+":"+c.substr(1)+"]/";
        }else{
            window.location.href="/model3d/"+path_save+x0+":"+xt+":"+y0+":"+yt+":"+z0+":"+zt+":"+d+":"+c.substr(1)+"]/";
        }
    }

    function decode( string ) { // ngubah string ke data array
	
        var output = [];
        var output_custom = [];
        var alf_code = ["a","b","c","d","e","f","g","h","i","j","k","l","m","n","o","p","q","r","s","t","u","v","w","x","y","z","A","B","C","D","E","F"],
		bin_code = ["00000","00001","00010","00011","00100","00101","00110","00111","01000","01001","01010","01011","01100","01101","01110","01111","10000","10001","10010","10011","10100","10101","10110","10111","11000","11001","11010","11011","11100","11101","11110","11111"];
        string_2 = string.split("[")[0];
        string_2.split(";").forEach(
            function ( v ) {
						function checkindex(i) {
						return i == v;
					}
					if(alf_code.includes(v)){
						v = bin_code[alf_code.findIndex(checkindex)];
					}
						output.push(parseInt(v)); 
					}
        );
        return output;

    }

    function buildFromHash() { // fungsi ini hanya akan dipanggil apabila sudah pernah ada kubus sebelumnya
        
        var path_save = window.location.pathname.substr( 8 ), // variable hash digunakan untuk mengambil string url dimulai dari setelah # (makanya substring(1)). 
        version = path_save.substr( 0, 2 ); // version dipake buat ngecek string A/ karena kalau udah pernah ada yang ngisi, di url pasti ada A/
        if ( version == "A:" ) { // kondisi jika ada A/ (sudah pernah ada kubus sebelumnya)
            var current = { x: 0, y: 0, z: 0, c: 0}
            var data = decode( path_save.substr( 2 ) );
            var data_x = [], data_y = [], data_z = [];
            var i = 0, l = data.length;

            while ( i < l ) {
                var code = data[ i ++ ].toString(); // mengubah data ke format string

                if ( code.charAt( 1 ) == "1" ) current.x += data[ i ++ ];
                if ( code.charAt( 2 ) == "1" ) current.y += data[ i ++ ];
                if ( code.charAt( 3 ) == "1" ) current.z += data[ i ++ ];
                if ( code.charAt( 4 ) == "1" ) current.c += data[ i ++ ];
                if ( code.charAt( 0 ) == "1" ) {

                    data_x.push(current.x * 50 + 25);
                    data_y.push(current.y * 50 + 25);
                    data_z.push(current.z * 50 + 25);
                    }
                }
            }
            return [data_x,data_y,data_z];
        }

    </script>

</div>

{% endblock content %}